#!/usr/bin/perl
#
# Program: bpjoin.cgi
# Author: Drummond Miles
# Email: info@gadnet.com
#
# Created: 29/12/98
# Last Modified:
# Copyright G.A.D.Miles 1998. All Rights Reserved
#
# Download script from http://www.gadnet.com/bpplus
#
# This program is being distibuted as freeware. It can be freely downloaded and used.
# It may be modified as long as the copyright information remains intact.
#
# Any use of this program is entirely at the risk of the user. No liability will be
# accepted by the author.
#
# This code must not be sold, even in modified form, without the written permission
# of the author. This code must also not be distributed without the permission of the 
# author.

$cgipath = $ENV{'SCRIPT_FILENAME'};
$cgipath =~ s/\/bpjoin.cgi//;
require "bpvars.txt";
require "bpsubs.cgi";

print "Content-type: text/html\n\n";

read(STDIN,$indata,$ENV{'CONTENT_LENGTH'});
@indata = split(/&/,$indata);
foreach $i (0..$#indata)
{
 	$indata[$i] =~ s/\+/ /g;
      ($key,$val) = split(/=/,$indata[$i],2);
	$key =~ s/%(..)/pack("c",hex($1))/ge;
	$val =~ s/%(..)/pack("c",hex($1))/ge;
	$indata{$key} .= "\0" if (defined($indata{$key}));
	$indata{$key} .= $val;
}

if ($ENV{'QUERY_STRING'} =~ /new/)
{
	&newuser;
}
elsif ($indata{'adduser'})
{
	&adduser;
}

sub newuser
{
	if ($autoname eq "Y")
	{
		open (DEFAULT, "+<$cgipath/default.txt") or die "can't open default.txt\n";
		$lockfail = &lock("DEFAULT");
		if ($lockfail)
		{
			&lockerror("default.txt");
		}
		@defaults = <DEFAULT>;
		chop $defaults[2] if ($defaults[2] =~ /\n$/);
		$defaults[2]++;
		seek (DEFAULT,0,0);
		foreach $defaults (@defaults)
		{
			chop $defaults if ($defaults =~ /\n$/);
			print DEFAULT "$defaults\n";
		}
		close (DEFAULT);
                $id = "bp" . $defaults[2];
	}
	&header('s|');
	print("<form method=POST action=$cgiurl/bpjoin.cgi>\n");
	print("<input type=hidden name=adduser value=x>\n");
	if ($autoname eq "Y")
	{
		print("<input type=hidden name=userid value=$id>\n");
	}
	print("<center><table BORDER WIDTH=75\%>\n");
	print("<tr><th ALIGN=CENTER BGCOLOR=\"#FF0000\"><b><font face=verdana><font color=\"#00FF00\"><font size=+0>|H:</font></font></font></b></th></tr>\n");
	print("<tr BGCOLOR=\"#FFFF00\"><td><center><table><tr><td ALIGN=RIGHT><font size=-1>| ID:</font></td>\n");
	if ($autoname eq "Y")
	{
		print("<td>$id</td></tr>\n");
	}
	else
	{
		print("<td><input type=text name=userid size=8 maxlength=8></td></tr>\n");
	}
	print("<tr><td ALIGN=RIGHT><font size=-1>KX:</font></td>\n");
	print("<td><input type=password name=userpass1 size=8 maxlength=8></td></tr>\n");
	print("<tr><td ALIGN=RIGHT><font size=-1>T{KX:</font></td>\n");
	print("<td><input type=password name=userpass2 size=8 maxlength=8></td></tr>\n");
	print("<tr><td ALIGN=RIGHT><font size=-1>zjW:</font></td>\n");
	print("<td><input type=text name=username size=20 maxlength=30></td></tr>\n");
	print("<tr><td ALIGN=RIGHT><font size=-1>Email:</font></td>\n");
	print("<td><input type=text name=email size=30 maxlength=50></td></tr>\n");
	print("</table></center></td></tr></table></center>\n");
	print("<center><table BORDER WIDTH=75\%>");
	print("<tr><th ALIGN=CENTER BGCOLOR=\"#FF0000\"><b><font face=verdana><font color=\"#00FF00\"><font size=+0>zH:</font></font></font></b></th></tr>\n");
	print("<tr BGCOLOR=\"#FFFF00\"><td><center><table><tr><td ALIGN=RIGHT><font size=-1>}:</font></td>\n");
      print("<td><input type=text name=siteurl size=40 maxlength=60></td></tr>\n");
	print("<tr><td ALIGN=RIGHT><font size=-1>W:</font></td>\n");
	print("<td><input type=text name=sitetitle size=40 maxlength=60></td></tr>\n");
	print("<td ALIGN=RIGHT><font size=-1>siϼЦa}:</font></td>\n");
	print("<td><input type=text size=40 name=urlbanner maxlength=60></td></tr></table>\n");
	print("</td></tr></table></center>\n");
	print("<center><input type=submit value=\"U@B\">\n");
	print("</form></center>\n");
	&footer;
}

sub adduser
{
	&header('s|');
	$error = 0;
	if ($indata{'userid'})
	{
                if (-e "$bpdata/$indata{'userid'}.txt")
		{
			$error = 1;
			print("<br><br><center><b><font size=+1>~<br><br></font></b>\n");
			print("<b>oӥΤIDwgQ`U</b>\n");
		}
	}
	if (!$indata{'userid'})
	{
		if (!$error)
		{
			print("<br><br><center><font size=+1><b>~<br><br></font></b>\n");
			$error = 1;
		}
		print("<b>zCΤ ID<br></b>\n");
	}
	if ($indata{'userid'} =~ / /)
	{
		if (!$error)
		{
			print("<br><br><center><font size=+1><b>Error<br><br></font></b>\n");
			$error = 1;
		}
		print("<b>ΤID]tŮ<br></b>\n");
	}
	if (!$indata{'userpass1'})
	{
		if (!$error)
		{
			print("<br><br><center><font size=+1>~<br><br></font></b>\n");
			$error = 1;
		}
		print("<b>zCKX<br></b>\n");
	}
	if ($indata{'userpass1'} ne $indata{'userpass2'})
	{
		if (!$error)
		{
			print("<br><br><center><b><font size=+1>~<br><br></font></b>\n");
			$error = 1;
		}
		print("<b>GJKX@P<br></b>\n");
	}
	if (!$indata{'username'})
	{
		if (!$error)
		{
			print("<br><br><center><b><font size=+1>~<br><br></font></b>\n");
			$error = 1;
		}
		print("<b>zJzWl<br></b>\n");
	}
	if (!$indata{'email'})
	{
		if (!$error)
		{
			print("<br><br><center><b><font size=+1>~<br><br></font></b>\n");
			$error = 1;
		}
		print("<b>zJzEmaila}<br></b>\n");
	}
	if (!$indata{'siteurl'})
	{
		if (!$error)
		{
			print("<br><br><center><b><font size=+1>~<br><br></font></b>\n");
			$error = 1;
		}
		print("<b>zJz<br></b>\n");
	}
	if (!$indata{'sitetitle'})
	{
		if (!$error)
		{
			print("<br><br><b><center><font size=+1>~<br><br></font></b>\n");
			$error = 1;
		}
		print("<b>zJzW<br></b>\n");
	}
	if ($error)
	{
		print ("<br><br><center> \'Back\' s^ssƾ</center>\n");
		return;
	}

	open (DEFAULT, "+<$cgipath/default.txt") or die "can't open default.txt\n";
	$lockfail = &lock("DEFAULT");
	if ($lockfail)
	{
		&lockerror("default.txt");
	}
	@defaults = <DEFAULT>;
	close (DEFAULT);

	open (NEWUSER, ">$bpdata/$indata{'userid'}.txt");
	$lockfail = &lock("NEWUSER");
	if ($lockfail)
	{
		&lockerror("$indata{'userid'}.txt");
	}
	print NEWUSER "$indata{'username'}\n";
	print NEWUSER "$indata{'email'}\n";
	print NEWUSER "$indata{'siteurl'}\n";
	print NEWUSER "$indata{'urlbanner'}\n";
	print NEWUSER "0\n";
	print NEWUSER "$defaults[0]";
	print NEWUSER "0\n";
	print NEWUSER "0\n";
	print NEWUSER "$indata{'userpass1'}\n";
	print NEWUSER "$indata{'sitetitle'}\n";
	$year = (localtime)[5] + 1900;
	$month = (localtime)[4] + 1;
	if ($month < 10)
	{
		$month = "0".$month;
	}
	$day = (localtime)[3];
	if ($day < 10)
	{
		$day = "0".$day;
	}
	$date = $year.$month.$day;
	print NEWUSER "$date\n";
	print NEWUSER "$date\n";
	print NEWUSER "\n";
	print NEWUSER "0\n";
	print NEWUSER "$defaults[1]";
	&asendmail;#[J
	close (NEWUSER);
	open (UNVERIFIED, ">>$bpdata/members.txt");
	$lockfail = &lock("UNVERIFIED");
	if ($lockfail)
	{
		&lockerror("members.txt");
	}
	seek (UNVERIFIED,0,2);
      print UNVERIFIED "$indata{'userid'}\n";
	close (UNVERIFIED);
	print "<br><br><center><font face=verdana><font size +2>| <b>$indata{'userid'}</b> ӽЧ</font></font>\n";
	print "<br><br>ziHNUCNX_ \& ߶KzW:</center>\n";
      &htmlcode($indata{'userid'});
	print "<br><br>z 01 99 ƦrG <b><font color=\"#FF0000\">XX</font></b> A\n";
	print "BΦP˪Ʀrܳo<b><font color=\"#FF0000\">XX</font></b><br>\n";
	print "pGzmNXbPWAӨCӭW<b><font color=\"#FF0000\">XX</font></b>ΤPƦr. \n";
	print "yܻ, pGzmoӥNXbӭW,  <b><font color=\"#FF0000\">XX</font></b> bĤ@wgF 01 \bĤGӭW 02<br>\n";
	print "WzNXڭ̤woezHc\n";
}

#HU[J
sub asendmail
{
      open (MAIL,"|$mailprog $indata{'email'}") || die "Can't open $mailprog!\n";
      print MAIL "Reply-to: $myemail\n";
      print MAIL "From:$myemail\n";
      print MAIL "To:$indata{'email'}\n";
      print MAIL "Subject:$title\n\n";
      open (FILE,"$mesg") || die "Can not open message";
      while (<FILE>){
        s/--name--/$indata{'username'}/g;
        s/--uid--/$indata{'userid'}/g;
        s/--passwd--/$indata{'userpass1'}/g;
        print MAIL $_;
      }
      close (FILE);
      close (MAIL);
}      